
<template>
  <div>
    <!-- Cuerpo -->
    <div style="margin: 0 10rem" class="padding-top">
      <el-header height="110px">
        <ReturnButton
          :isValidate="false"
          v-on:clickEvent="returnPage"
          title="Regresar"
          :offsetArrow="21"
          :spanTitle="2"
          class="text-end"
        />
        <!-- Modal botón regresar -->
        <AppModal
          :show-dialog.sync="returnButtonModal"
          v-if="returnButtonModal"
          nameClass="dialog-red"
          :rutImg="require(`@/assets/images/alerta.svg`)"
          sizeImg="80%"
          textBold="¿Estás seguro?"
          :parrafo="'Si sales del formulario, la información se perderá. '"
          classBtn1="border-red"
          typeBtn1="danger"
          btn1="Salir"
          btn2="Seguir aquí"
          @btnEvent="returnToGrill"
          v-on:btnEvent="returnButtonModal = false"
          v-on:eventBtn="returnButtonModal = false"
        ></AppModal>

        <!-- Titulo del Programa -->
        <el-col :span="24">
          <div
            class="titleSection"
          >PROGRAMACIÓN {{typeChannel}} - {{ newGrid.programInfo.programTitle }}</div>
        </el-col>
      </el-header>

      <el-main>
        <div
          v-for="(day, index) in newGrid.cardsData"
          :key="index"
          :body-style="{ padding: '0px' }"
          style="margin-top: 2rem"
          shadow="hover"
        >
          <TitleCard :title="day.materialTitle" :day="day.completeDate" />
          <el-card>
            <div style="padding: 3rem 2.5rem 0">
              <!-- Elegir un material -->
              <p class="subtitle-styles text-orange" style="margin-bottom: 1.5rem">MATERIAL:</p>
              <el-row :gutter="20" style="margin: 2rem 0">
                <el-col :span="5" :offset="1">
                  <p class="fonts-bold-general">¿El material existe?</p>
                </el-col>
                <el-col :span="7" :offset="1">
                  <!-- @change="deleteInfoMaterial(day, day.materialExisting)" -->
                  <el-radio
                    @change="deleteInfoMaterial(day, day.materialExisting)"
                    v-model="day.materialExisting"
                    label="Si"
                  >Si</el-radio>
                  <el-radio
                    @change="deleteInfoMaterial(day, day.materialExisting)"
                    v-model="day.materialExisting"
                    label="No"
                  >No</el-radio>
                </el-col>
              </el-row>
              <el-row :gutter="20" style="margin: 2rem 0">
                <el-col :span="5" :offset="1" v-if="isMaterialExist(day.materialExisting)">
                  <p style="margin-bottom: 0.5rem">
                    <strong>Código:</strong>
                  </p>
                  <el-input
                    v-if="day.materialExisting == 'Si'"
                    v-model="day.codMaterial"
                    @keyup.enter.native="findMaterialByCode(index, day)"
                    @blur="verifyIfHasContent(day)"
                    size="mini"
                  ></el-input>
                  <el-input v-else v-model="day.codMaterial" size="mini"></el-input>
                </el-col>
                <el-col
                  :span="17"
                  :offset="1"
                  v-bind:class="[isMaterialExist(day.materialExisting)? '' : 'flex']"
                >
                  <p style="margin-bottom: 0.5rem; margin-right: 15px">
                    <strong>Título:</strong>
                  </p>
                  <el-autocomplete
                    v-if="day.materialExisting == 'Si'"
                    v-model="day.materialTitle"
                    style="width: 100%;"
                    size="mini"
                    :fetch-suggestions="querySearch"
                    :trigger-on-focus="false"
                    @select="handleSelect"
                    @blur="verifyIfHasContentAll(day, newGrid.cardsData)"
                    v-on:select="findMaterialByName(index, day)"
                  >
                    <template slot-scope="props">
                      <div>{{ props.item.listTitle }}</div>
                    </template>
                  </el-autocomplete>
                  <el-input v-else v-model="day.materialTitle" size="mini"></el-input>
                </el-col>
              </el-row>
              <el-row
                v-if="showActorsSelect.statusGeneral && day.materialExisting == 'Si'"
                style="margin-bottom: 4rem"
              >
                <hr style="margin-bottom: 2rem" />
                <h4 class="text-orange" style="margin: 3rem 0 2rem">CARACTERÍSTICAS:</h4>

                <el-row type="flex" align="middle" style="margin: 2rem 0">
                  <el-col :span="6" :offset="1" class="fonts-bold-general">Nombre del Proveedor:</el-col>
                  <el-col :span="15">
                    <div>{{ nombreDelProveedor }}</div>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" style="margin: 2rem 0">
                  <el-col :span="6" :offset="1" class="fonts-bold-general">Posición en el Contrato:</el-col>
                  <el-col :span="3" :offset="1">
                    <div>{{ positionMat }}</div>
                  </el-col>
                </el-row>
                <el-row type="flex" align="middle" style="margin: 2rem 0">
                  <el-col :span="6" :offset="1" class="fonts-bold-general">Código de Largometraje:</el-col>
                  <el-col :span="8">
                    <el-input v-model="day.codeFeatureFilm" size="small"></el-input>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle">
                  <el-col
                    v-if="itemObject.materialType && itemObject.materialType.includes('Enlatado') && itemObject.typeOfContent && itemObject.codeTypeContent == '010'"
                    :span="6"
                    :offset="1"
                    class="fonts-bold-general"
                  >Actores Principales:</el-col>
                  <el-col v-else :span="6" :offset="1" class="fonts-bold-general">Conductores:</el-col>
                  <el-col :span="8">
                    <el-select
                      v-model="day.firstActor"
                      placeholder="Seleccionar"
                      size="small"
                      style="width: 100%;"
                      v-if="showActorsSelect.statusSelect"
                    >
                      <el-option
                        v-for="(actor, index) in day.actorsPreliminary"
                        :key="index"
                        :label="actor"
                        :value="actor"
                      ></el-option>
                    </el-select>
                    <el-input v-model="day.firstActor" size="small" v-else></el-input>
                  </el-col>

                  <el-col :span="8" :offset="1">
                    <el-select
                      v-model="day.secondActor"
                      placeholder="Seleccionar"
                      size="small"
                      style="width: 100%;"
                      v-if="showActorsSelect.statusSelect"
                    >
                      <el-option
                        v-for="(actor, index) in day.actorsPreliminary"
                        :key="index"
                        :label="actor"
                        :value="actor"
                      ></el-option>
                    </el-select>
                    <el-input v-model="day.secondActor" size="small" v-else></el-input>
                  </el-col>
                </el-row>
                <el-row type="flex" align="middle" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Precio del capítulo:</el-col>
                  <el-col :span="2" :offset="1">
                    <el-input
                      v-model="day.chapters[0].currencySymbolChap = 'USD'"
                      size="small"
                      disabled
                    ></el-input>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-input v-model="day.chapters[0].priceByChap" type="number" size="small"></el-input>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Precio por pasada:</el-col>
                  <el-col :span="2" :offset="1">
                    <el-input
                      v-model="day.chapters[0].currencySymbol = 'USD'"
                      size="small"
                      disabled
                    ></el-input>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-input v-model="day.chapters[0].priceByPass" size="small" type="number"></el-input>
                  </el-col>
                </el-row>
              </el-row>

              <el-row v-if="day.materialExisting == 'No'">
                <hr style="margin-bottom: 2rem" />
                <h4 class="text-orange" style="margin: 3rem 0 2rem">CARACTERÍSTICAS:</h4>
                <el-row :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1">
                    <p class="fonts-bold-general">¿Tiene Capítulos?</p>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-radio
                      @change="hasChapter(day)"
                      v-model="day.materialHasChapter"
                      label="Si"
                    >Si</el-radio>
                    <el-radio
                      @change="hasChapter(day)"
                      v-model="day.materialHasChapter"
                      label="No"
                    >No</el-radio>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1">
                    <span class="fonts-bold-general">Tipo de Material:</span>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-cascader
                      size="small"
                      style="width: 100%;"
                      placeholder="Seleccionar"
                      expand-trigger="hover"
                      :options="optionsMat"
                      @change="changeMaterialType"
                      v-model="day.materialType"
                    ></el-cascader>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1">
                    <span class="fonts-bold-general">Tipo de Contenido:</span>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-autocomplete
                      placeholder="Seleccionar"
                      v-model="day.typeOfContent"
                      style="width: 100%;"
                      size="small"
                      :fetch-suggestions="querySearchNameCostCenter"
                      :trigger-on-focus="false"
                      @select="handleSelectCostCenter"
                      v-on:select="showTypeOfContent(index, day)"
                    >
                      <template slot-scope="props">
                        <div>{{ props.item.label }}</div>
                      </template>
                    </el-autocomplete>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1">
                    <span class="fonts-bold-general">Clasificación:</span>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-select
                      v-model="day.classification"
                      placeholder="Seleccionar"
                      size="small"
                      style="width: 100%;"
                    >
                      <el-option
                        v-for="typeOfContent in optionClasification"
                        :key="typeOfContent.value"
                        :label="typeOfContent.label"
                        :value="typeOfContent.value"
                      ></el-option>
                    </el-select>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Precio del material:</el-col>
                  <el-col :span="3" :offset="1">
                    <el-input
                      v-model="day.chapters[0].currencySymbolChap = 'USD'"
                      size="small"
                      disabled
                    ></el-input>
                  </el-col>
                  <el-col :span="7">
                    <el-input v-model="day.chapters[0].priceByChap" size="small"></el-input>
                  </el-col>
                </el-row>

                <el-row type="flex" align="middle" :gutter="20" style="margin: 2rem 0">
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Precio por pasada:</el-col>
                  <el-col :span="3" :offset="1">
                    <el-input
                      v-model="day.chapters[0].currencySymbol = 'USD'"
                      size="small"
                      disabled
                    ></el-input>
                  </el-col>
                  <el-col :span="7">
                    <el-input v-model="day.chapters[0].priceByPass" size="small"></el-input>
                  </el-col>
                </el-row>

                <el-row
                  v-if="day.materialType && day.materialType.includes('Enlatado') && day.typeOfContent == 'Largometrajes'"
                  type="flex"
                  align="middle"
                  style="margin: 2rem 0"
                >
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Código de Largometraje:</el-col>
                  <el-col :span="7" :offset="1" style="padding-left: 10px">
                    <el-input size="small" v-model="day.codeFeatureFilm"></el-input>
                  </el-col>
                </el-row>
              </el-row>

              <el-input v-if="false" v-model="day.idMaterialRef" size="small"></el-input>

              <el-row
                style="margin: 3rem 0"
                v-if="day.materialExisting == 'No' && day.materialHasChapter == 'No' && day.typeOfContent == 'Largometrajes'"
              >
                <h4 class="text-orange">INFORMACIÓN ARTÍSTICA:</h4>
                <el-row style="margin: 3rem 0 0">
                  <el-col :span="5" :offset="1">
                    <el-checkbox
                      v-model="day.theyAreVoiceActors"
                      style="margin-bottom:2rem"
                    >Actores de Voz</el-checkbox>
                  </el-col>
                </el-row>
                <el-row type="flex" align="middle">
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Actores Principales:</el-col>
                  <el-col :span="7">
                    <el-input v-model="day.firstActor" size="small"></el-input>
                  </el-col>
                  <el-col :span="7" :offset="1">
                    <el-input v-model="day.secondActor" size="small"></el-input>
                  </el-col>
                </el-row>
              </el-row>
              <el-row style="margin-bottom: 2rem" v-if="day.isShowTemporadas">
                <h4 class="text-orange" style="margin: 0 0 1rem">CAPÍTULOS:</h4>
                <el-col
                  :span="5"
                  :offset="1"
                  style="margin-right: 2rem; padding-left: 10px; padding-bottom: 10px;"
                  v-for="(chapter, i) in day.chapters"
                  :key="i"
                >
                  <el-col :span="12">
                    <el-input
                      v-model="chapter.numChapter"
                      @change="validPassOfChap( chapter.numChapter, day, i )"
                      size="mini"
                    ></el-input>
                  </el-col>
                  <el-col :span="12" v-if="day.chapters.length === 1" style="margin-top: 1px;">
                    <i
                      v-on:click="addChapter(i, index, chapter)"
                      class="el-icon-circle-plus text-orange"
                      style="font-size:25px; margin-left: 6px;"
                    ></i>
                  </el-col>
                  <el-col :span="12" v-else style="margin-top: 1px;">
                    <i
                      v-on:click="addChapter(i, index, chapter )"
                      class="el-icon-circle-plus text-orange"
                      style="font-size:25px; margin-left: 6px;"
                    ></i>
                    <i
                      v-on:click="deleteChapter(i, index)"
                      class="el-icon-remove text-dark-gray-2"
                      style="font-size:25px"
                    ></i>
                  </el-col>
                </el-col>
              </el-row>
              <!-- MATERIAL CON CAPITULOS -->

              <div v-if="day.isShowTemporadas">
                <el-row
                  v-for="(chapter, index) in day.chapters"
                  :key="index"
                  style="margin-bottom: 2rem"
                >
                  <hr style="margin-bottom: 2rem" />
                  <h4 class="text-orange" style="margin: 3rem 0 2rem">CARACTERÍSTICAS:</h4>

                  <el-row type="flex" align="middle" style="margin: 2rem 0">
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Precio del capítulo:</el-col>
                    <el-col :span="2" :offset="1">
                      <el-input
                        v-model="day.chapters[index].currencySymbolChap = 'USD'"
                        size="small"
                        disabled
                      ></el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input
                        v-model="day.chapters[index].priceByChap"
                        type="number"
                        size="small"
                      ></el-input>
                    </el-col>
                  </el-row>

                  <el-row type="flex" align="middle" style="margin: 2rem 0">
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Precio por pasada:</el-col>
                    <el-col :span="2" :offset="1">
                      <el-input
                        v-model="day.chapters[index].currencySymbol = 'USD'"
                        size="small"
                        disabled
                      ></el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input
                        v-model="day.chapters[index].priceByPass"
                        size="small"
                        type="number"
                      ></el-input>
                    </el-col>
                  </el-row>

                  <hr style="margin-bottom: 2rem" />
                  <el-col :span="9">
                    <el-row style="margin-bottom: 0.2rem">
                      <p style="margin-bottom: 1.5rem" class="text-orange">
                        <strong>TEMPORADA N° {{ chapter.season }}</strong>
                      </p>
                    </el-row>
                    <el-row style="margin-bottom: 1rem">
                      <el-col :span="11" :offset="3">
                        <p class="fonts-bold-general">N° de Temporada:</p>
                      </el-col>
                      <el-col :span="4" :offset="1">
                        <el-input
                          v-model="chapter.season"
                          size="mini"
                          v-on:keypress.native="isNumber"
                        ></el-input>
                      </el-col>
                    </el-row>
                    <el-col :offset="3">
                      <!-- <el-checkbox v-model="chapter.seasonInfo" class="statusCheck">Inicio de Temporada</el-checkbox>
                      <el-checkbox v-model="chapter.seasonInfo" class="statusCheck">Fin de Temporada</el-checkbox>-->

                      <el-radio
                        v-model="chapter.seasonInfo"
                        label="Inicio de Temporada"
                        style="margin: 0 0 5px; display: block;"
                      >Inicio de Temporada</el-radio>
                      <el-radio
                        v-model="chapter.seasonInfo"
                        label="Fin de Temporada"
                        style="margin: 0; display: block;"
                      >Fin de Temporada</el-radio>
                    </el-col>
                  </el-col>
                  <el-col :span="9" :offset="1">
                    <p style="margin-bottom: 1.5rem" class="text-orange">
                      <strong>ESTADO DEL CAPÍTULO N° {{ chapter.numChapter }}</strong>
                    </p>
                    <el-col :offset="3">
                      <el-checkbox v-model="chapter.rerun" class="statusCheck">Rerun</el-checkbox>
                      <el-checkbox v-model="chapter.estreno" class="statusCheck">Estreno</el-checkbox>
                      <el-checkbox v-model="chapter.ongoing" class="statusCheck">Ongoing</el-checkbox>
                    </el-col>
                  </el-col>
                </el-row>
              </div>

              <!-- MATERIAL SIN CAPITULOS -->
              <!--  v-else -->
              <div v-else>
                <el-row
                  v-for="(chapter, index) in day.chapters"
                  :key="index"
                  style="margin-bottom: 2rem"
                >
                  <hr style="margin-bottom: 2rem" />
                  <el-input v-if="false" v-model="chapter.numChapter = 1" size="mini"></el-input>
                  <h4
                    v-if="day.materialExisting == 'Si' && !showActorsSelect.statusGeneral"
                    class="text-orange"
                    style="margin: 3rem 0 2rem"
                  >CARACTERÍSTICAS:</h4>
                  <el-row
                    v-if="day.materialExisting == 'Si' && !showActorsSelect.statusGeneral"
                    type="flex"
                    align="middle"
                    style="margin: 2rem 0"
                  >
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Precio del material:</el-col>
                    <el-col :span="2" :offset="1">
                      <el-input v-model="chapter.currencySymbolChap = 'USD'" size="small" disabled></el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input v-model="chapter.priceByChap" type="number" size="small"></el-input>
                    </el-col>
                  </el-row>

                  <el-row
                    v-if="day.materialExisting == 'Si' && !showActorsSelect.statusGeneral"
                    type="flex"
                    align="middle"
                    style="margin: 2rem 0"
                  >
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Precio por pasada:</el-col>
                    <el-col :span="2" :offset="1">
                      <el-input v-model="chapter.currencySymbol = 'USD'" size="small" disabled></el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input v-model="chapter.priceByPass" size="small" type="number"></el-input>
                    </el-col>
                  </el-row>
                  <hr
                    v-if="day.materialExisting == 'Si' && !showActorsSelect.statusGeneral"
                    style="margin-bottom: 2rem"
                  />
                  <p style="margin-bottom: 1.5rem" class="text-orange">
                    <strong>ESTADO</strong>
                  </p>
                  <el-col :span="9" :offset="1">
                    <el-checkbox v-model="chapter.rerun" class="statusCheck">Rerun</el-checkbox>
                    <el-checkbox v-model="chapter.estreno" class="statusCheck">Estreno</el-checkbox>
                    <el-checkbox v-model="chapter.ongoing" class="statusCheck">Ongoing</el-checkbox>
                  </el-col>
                </el-row>
              </div>

              <!-- HORARIO DEL PROGRAMA -->
              <h4 class="text-orange" style="margin: 3rem 0 2rem">HORARIO DEL PROGRAMA</h4>
              <el-row style="margin-bottom:3rem">
                <el-col :span="11" :offset="1">
                  <el-row type="flex" align="middle">
                    <el-col :span="4">
                      <span class="font-general">Inicio:</span>
                    </el-col>
                    <el-col :span="7">
                      <el-input
                        size="small"
                        v-model="day.scheduleStartHour"
                        placeholder="00"
                        v-on:keypress.native="isNumber"
                        maxlength="2"
                      >
                        <template slot="append">hr</template>
                      </el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input
                        size="small"
                        v-model="day.scheduleStartMin"
                        placeholder="00"
                        v-on:keypress.native="isNumber"
                        ref="jump1"
                        maxlength="2"
                      >
                        <template slot="append">min</template>
                      </el-input>
                    </el-col>
                  </el-row>
                </el-col>

                <el-col :span="11" :offset="1">
                  <el-row type="flex" align="middle">
                    <el-col :span="4">
                      <span class="font-general">Fin:</span>
                    </el-col>
                    <el-col :span="7">
                      <el-input
                        size="small"
                        v-model="day.scheduleEndHour"
                        placeholder="00"
                        v-on:keypress.native="isNumber"
                        ref="jump2"
                        maxlength="2"
                      >
                        <template slot="append">hr</template>
                      </el-input>
                    </el-col>
                    <el-col :span="7" :offset="1">
                      <el-input
                        size="small"
                        v-model="day.scheduleEndMin"
                        placeholder="00"
                        v-on:keypress.native="isNumber"
                        ref="jump3"
                        maxlength="2"
                      >
                        <template slot="append">min</template>
                      </el-input>
                    </el-col>
                  </el-row>
                </el-col>
              </el-row>

              <el-row v-if="index !== (newGrid.cardsData.length -1)">
                <el-col :offset="21" :span="3" style="text-align: right;">
                  <el-button
                    size="small"
                    type="primary"
                    @click="copyButton(index, day, newGrid.cardsData)"
                  >COPIAR</el-button>
                </el-col>
              </el-row>
            </div>
          </el-card>
        </div>

        <!-- :disabled="isInCompleteForm" -->
        <!-- Botones cancelar y programar -->
        <div class="text-end" style="margin-top: 3rem">
          <el-button
            v-on:click="modalCancelButton = true"
            class="text-orange border-orange"
            plain
          >CANCELAR</el-button>
          <!-- <el-button @click="savingChangesOfWeek" type="primary" style="margin-left: 3rem">PROGRAMAR</el-button> -->
          <el-button @click="checkCrosses" type="primary" style="margin-left: 3rem">PROGRAMAR</el-button>
        </div>

        <!-- Modal botón cancelar -->
        <AppModalDanger
          :show-dialog.sync="modalCancelButton"
          v-if="modalCancelButton"
          @btnEvent="modalCancelButton = false"
          v-on:btnEvent="returnToGrill"
          v-on:eventBtn="modalCancelButton = false"
        ></AppModalDanger>

        <AppModal
          :show-dialog.sync="dialogVisible"
          v-if="dialogVisible"
          nameClass="dialog-red"
          :rutImg="require(`@/assets/images/alerta.svg`)"
          sizeImg="80%"
          :parrafo="totalPassExcess"
        ></AppModal>

        <!-- MODAL CUANDO NO INGRESA LOS MATERIALES -->
        <AppModal
          :show-dialog.sync="noInfoToSave"
          v-if="noInfoToSave"
          nameClass="dialog-red"
          :rutImg="require(`@/assets/images/alerta.svg`)"
          sizeImg="80%"
          :parrafo="textNoInfoToSave"
        ></AppModal>

        <!-- MODAL CUANDO NO El MATERIAL NO TIENE AL MENOS UNA DE LAS MISMAS SEÑALES DEL PROGRAMA -->
        <AppModal
          :show-dialog.sync="notHaveSignalForProgram"
          v-if="notHaveSignalForProgram"
          nameClass="dialog-red"
          :rutImg="require(`@/assets/images/alerta.svg`)"
          sizeImg="80%"
          :parrafo="textNotHaveSignalForProgram"
        />
        <!-- Modal checkCrosses -->
        <el-dialog
          :visible.sync="checkCrossesModal"
          width="40%"
          :close-on-press-escape="false"
          :show-close="false"
          :close-on-click-modal="false"
          custom-class="dialog-orange"
        >
          <el-row>
            <el-col :span="5">
              <img src="@/assets/images/pensante.svg" alt="emoticon" width="80%" />
            </el-col>
            <el-col :span="18" :offset="1">
              <p style="margin-bottom:1.5rem" class="subtitle-styles line-height: 22px">¡Espera!</p>
              <p style="line-height: 22px;" v-for="(item, index) in arrCheckCrosses" :key="index">
                <span style="line-height: 22px">
                  El programa del
                  <strong>{{ item.completeDate.split(' ')[0]}}</strong> ocupará:
                </span>
                <span>
                  {{item.time }} de
                  <strong>"{{item.title}}"</strong>
                </span>
              </p>
              <div class="text-end" style="margin-top: 3rem">
                <el-button
                  @click="checkCrossesModal = false"
                  v-on:click="cleanArrcheckCrosses"
                  class="border-orange text-orange"
                  plain
                >CANCELAR</el-button>
                <el-button
                  @click="checkCrossesModal = false"
                  v-on:click="reducingSchedules(newGrid)"
                  type="primary"
                >ACEPTAR</el-button>
              </div>
            </el-col>
          </el-row>
        </el-dialog>
      </el-main>

      <!-- ALERTAS -->
      <!-- Modal botón copiar -->
      <AppModal
        :show-dialog.sync="modalCopy"
        v-if="modalCopy"
        nameClass="dialog-red"
        :rutImg="require(`@/assets/images/suspicious.svg`)"
        sizeImg="80px"
        textBold="¡Un momento!"
        :parrafo="paragraph"
        classBtn1="border-red"
        typeBtn1="danger"
        btn1="SÍ, COPIAR"
        btn2="CANCELAR"
        @btnEvent="saveCopy()"
        v-on:eventBtn="modalCopy = false"
      ></AppModal>

      <AppModalSuccess
        :show-dialog.sync="modalToGoBack"
        v-if="modalToGoBack"
        :styleModal="true"
        :parrafo="textAboutModalToGoBack"
        btn1="OK"
        @btnEvent="returnToGrill()"
      ></AppModalSuccess>

      <AppModal
        :show-dialog.sync="modalUpdateToGoBack"
        v-if="modalUpdateToGoBack"
        nameClass="dialog-orange"
        :rutImg="require(`@/assets/images/happy.svg`)"
        sizeImg="80%"
        :parrafo="textAboutModalToGoBackUpdate"
        :textBold="textBoldUpdateModal"
        btn1="OK"
        @btnEvent="returnToGrill()"
        :styleModal="true"
        classBtn1="border-orange"
      />
      <AppModal
        :show-dialog.sync="modalPassForChapExcess"
        v-if="modalPassForChapExcess"
        nameClass="dialog-red"
        :rutImg="require(`@/assets/images/alerta.svg`)"
        sizeImg="80%"
        :styleModal="true"
        textBold="¡Ups!"
        :parrafo="textModalPassForChapExcess"
        btn1="OK"
        @btnEvent="deleteThisChapExcess()"
        classBtn1="border-red"
        typeBtn1="danger"
      />
    </div>
  </div>
</template>

<script>
// import AppNav from '@/components/AppNav.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '@/utils/modifyText.js'
import AppModal from '@/components/AppModal.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import componentSignal from '@/components/componentSignal.vue'
import TitleCard from '@/components/grid/titleCard.vue'
import CardProgram from '@/components/grid/cardProgram.vue'
import { addTimes, restTimes, secondsToTime, calculateHour } from '@/utils/calculateTime.js'
import { convertHourDate, arraySignalCode, convertFormatDayForCrusses } from '@/utils/calculateTimePrograms.js'
import { HTTP } from '@/main.js'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import moment from 'moment'

export default {
  name: "programGridPreliminary",
  components: {
    ReturnButton,
    AppModal,
    AppModalDanger,
    componentSignal,
    TitleCard,
    CardProgram,
    AppModalSuccess,
  },
  data () {
    let type = this.$route.params.type
    return {
      dialogVisible: false,
      returnButtonModal: false,
      modalCancelButton: false,
      materialTitle: '',
      newGrid: {},
      codMaterial: '',
      handlePositionIndex: '',
      gridToUpdate: [],
      itemObject: {},
      materialTitle: '',
      exceeded: '',
      codigoMaterial: null,
      typeChannel: type,
      noInfoToSave: false,
      crushedPrograms: [],
      arrCheckCrosses: [],
      checkCrossesModal: false,
      programasModifyCrushed: [],
      modalOfChapterValidation: false,
      textModal: '',
      textNoInfoToSave: 'No ha ingresado información para ningún día de la programación',
      totalPassExcess: '',
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      continueValidation: '',
      checkAll: false,
      isIndeterminate: true,
      signalModal: false,
      signals: [],
      signalsTable: [],
      signalsByCode: [],
      signalsTrans: [],
      arrSignalsCode: [],
      isHaveAllSignalProgram: [],
      changeSignals: [],
      daysWithClosureOrcl: [],
      isInScheduleComplete: false,
      originalInfoOfGrid: '',
      isChapInComplete: false,
      notHaveSignalForProgram: false,
      textNotHaveSignalForProgram: 'Este material no tiene la misma señal que el programa',
      signalsTransCopy: [],
      channelTransmition: this.$localStorage.get('channelTransmition'),
      paragraph: '¿Quieres copiar la información de la programación este día, para los días siguientes?',
      modalCopy: false,
      indexToCopy: '',
      alertPrevToSave: false,
      modalToGoBack: false,
      modalUpdateToGoBack: false,
      totalDePasadas: 0,
      itemPassSelect: {},
      daySelected: null,
      modalPassForChapExcess: false,
      textModalPassForChapExcess: '',
      reviewDayExcess: null,
      itemObjectCopy: {},
      isMatOfGeminisContent: null,
      isSupportDataOfGeminisContent: null,
      textAboutModalToGoBack: 'Se ha realizado correctamente la programación.',
      textAboutModalToGoBackUpdate: 'Se ha actualizado correctamente la programación.',
      textBoldUpdateModal: '¡Buen trabajo!',
      optionClasification: [
        {
          value: 'APT',
          label: 'Apto para todo publico' 
        },
         {
          value: 'M14',
          label: 'Mayores de 14'
        },
         {
          value: 'M18',
          label: 'Mayores de 18'
        },
         {
          value: 'GP',
          label: 'Guia Paterna'
        }
      ],
      optionsTypeOfContent: [
        {
          value: '300',
          label: 'Cocina'
        },
           {
          value: '070',
          label: 'Cómico'
        },
           {
          value: '111',
          label: 'Deportivo'
        },
           {
          value: '080',
          label: 'Dibujos'
        },
           {
          value: '300',
          label: 'Electoral'
        },
          {
          value: '090',
          label: 'Entretenimiento'
        },
          {
          value: '300',
          label: 'Entrevista'
        },
         {
          value: '060',
          label: 'Especial'
        },
         {
          value: '300',
          label: 'Femenino'
        },
         {
          value: '080',
          label: 'Infantil'
        },
         {
          value: '300',
          label: 'Magazine'
        },
         {
          value: '300',
          label: 'Microprograma'
        },
         {
          value: '040',
          label: 'Novelas'
        },
        {
          value: '010',
          label: 'Largometrajes'
        },
         {
          value: '600',
          label: 'Periodístico'
        },
         {
          value: '300',
          label: 'Político'
        },
        {
          value: '300',
          label: 'Religioso'
        },
         {
          value: '020',
          label: 'Series'
        },
         {
          value: '025',
          label: 'Miniseries'
        },
         {
          value: '060',
          label: 'Programas Especiales'
        },
           {
          value: '300',
          label: 'Talkshow'
        },
      ],
      optionsMat: [
        {
          value: 'Enlatado',
          label: 'Enlatado',   
        },
        {
          value: 'Afiliación',
          label: 'Afiliación',
          children: [{
            value: 'Televisa',
            label: 'Televisa'
          }]
        },
        {
          value: 'Producción Nacional',
          label: 'Producción Nacional',   
        },
        {
          value: 'Fusión Gourmet',
          label: 'Fusión Gourmet',   
        },
        {
          value: 'Otros',
          label: 'Otros',   
        },
      ],
      currencyArray: [
        {
        "value": "$",
        "label": "USD"
        },
        {
        "value": "€",
        "label": "EUR"
        },
        {
        "value": "S/.",
        "label": "PEN"
        }
      ],
      showActorsSelect: {
        statusGeneral: false,
        statusSelect: false,
        actors: []
      },
      actorsSelect: {
        firstActor: '',
        secondActor: ''
      },
      positionMat : null,
      nombreDelProveedor: null,
      typeOfContentAutocomplete: null,
      priceForDay: null,
      pricePassMovie: null
    }
  },
  created () {
    this.gettingUsername()
    this.programObj()
    this.getInitialData()
  },
  beforeDestroy() {
    this.$store.dispatch('getData', 'grid')
    this.$store.dispatch('getData', 'materials/allMaterials/allMaterials')
  },
  methods: {
    showTypeOfContent ( index, day ) {
      day.typeOfContent = this.typeOfContentAutocomplete
    },
    querySearchNameCostCenter (queryString, cb) {
      let links = this.optionsTypeOfContent
      let results = links.filter(
        link=>modifyText(link.label).toUpperCase().includes(modifyText(queryString).toUpperCase()))
      cb(results);
      this.typeOfContentAutocomplete = results
    },
    handleSelectCostCenter (item) {
      this.typeOfContentAutocomplete = item.label
    },
    changeMaterialType(value) {
      console.log(value, 'changeMaterialType')
      // let data = value.length == 2 ? value.join(', ') : value.join(' ')
      // console.log(data, 'data data')
      // return data
    },
    returnMaterialType(value) {
      return value ? [value] : []
    },
    deleteThisChapExcess() {
      const {chapters} = this.reviewDayExcess
      let lastElemtInsert = chapters[chapters.length -1]
      lastElemtInsert.numChapter = ''
      this.modalPassForChapExcess = false
    },
    async validPassOfChap(val, day, index) {
      let material = this.itemObject
      let existingCap = this.verifyExistingNumberCapInMaterial(val)
      let isCanned = this.isMaterialCanned(material.stringMaterialType)
      if (existingCap ) {
        // capitulo existe 
        if (isCanned && material.geminisCodeContract != '' ) {
          if ( this.isMaterialGenerateInInGrid(this.itemObject) ) {
            // material generado en IN_GRID
             let arrayDeCapitulos = material.numChapters[0].infoByChapter
             let filterCap = arrayDeCapitulos.filter( m => m.chapter == val )
             console.log(filterCap, 'filterCap')
             if (filterCap[0]) {
               let programDayIncludesInEmision = filterCap[0].emissionsPreliminary ? filterCap[0].emissionsPreliminary.includes(day.programDate) : true
              //se encontro el capitulo
               if (!programDayIncludesInEmision && filterCap[0].specificPass && filterCap[0].emissionsPreliminary && filterCap[0].specificPass <=  filterCap[0].emissionsPreliminary.length) {
                console.log('se consumio las pasadas del capitulo')
                day.chapters[index].numChapter = null
                this.notHaveSignalForProgram = true
                this.textNotHaveSignalForProgram = `Se consumio las pasadas del capitulo.`
              }
            }
          }
          // mostrar el precio tanto de los materiales generados en ingrid como los antiguos
          let selectDayNewGrid = this.newGrid.arrOfDays[index].programDate.split('T')
          let dayTransform = moment(selectDayNewGrid[0], "YYYY-MM-DD").format("DD-MM-YYYY")
          let codMaterial = this.itemObject.geminisCode
          let contractCode =  this.itemObject.geminisCodeContract ? this.itemObject.geminisCodeContract : this.itemObject.contractCode
          let infoPrice = await HTTP.get(`contracts/contractCode/${contractCode}/geminisCodeMaterial/${codMaterial}/numchapter/${val}/getPricePass/${dayTransform}`)   
          this.pricePassMovie = infoPrice.data
          this.$set(day.chapters[index], 'priceByPass', infoPrice.data)
        }
      }
      else {
        console.log('EL CAPITULO NO EXISTE ')
        this.textNotHaveSignalForProgram = `<p> El  capítulo <strong> ${val}</strong> <span class="text-red text-bold"> NO EXISTE </span> en este material.</p>`
        this.notHaveSignalForProgram = true
        day.chapters[index].numChapter = null

      }
    },
    isMaterialGenerateInInGrid (material) {
      if(material.codMaterial.includes('M')  ) {
        return true
      }
      else {
        return false
      }
    },
    verifyExistingNumberCapInMaterial (numberCap) {
      let existing
      if(Number(numberCap) == 0) {
        existing = false
      } else {
        let totalCap = Number(this.itemObject.numChapters[0].chapters)
        existing = Number(numberCap) <= totalCap ? true : false
      }
      return existing
    },
    restEmisions (numChapter, programDate) {
      let infoCap = this.itemObject.numChapters[0].infoByChapter.filter(function(item) {
        return item.chapter == Number(numChapter)
      })
      infoCap[0].emissionsPreliminary.splice(infoCap[0].emissionsPreliminary.indexOf(programDate), 1)
    },
    restPassConsumedMaterial (numChapter, chapterOriginal, programDate, objectGrid ) {
      console.log( objectGrid, 'objectGrid' )
      // PREGUNTO SI TIENE CAPITULOS
      if ( this.itemObject.numChapters.length > 0) { 
        let infoCap = this.itemObject.numChapters[0].infoByChapter.filter(function(item) {
          return item.chapter == Number(numChapter)
        })

       let totalPassByCap = this.itemObject.numChapters[0].arrOfChapters.filter(function(item) {
          return item.id == Number(numChapter)
        })

        
        if (infoCap[0] && !infoCap[0].emissionsPreliminary ) {
          this.$set(infoCap[0], "emissionsPreliminary", [] )
          this.$set(infoCap[0], "specificPass", Number(totalPassByCap[0].specificPass)) 
        }

        infoCap[0].emissionsPreliminary.push(programDate)
        //PROBANDO ANDO
        objectGrid.priceByPass =  totalPassByCap[0].chapterPasses[infoCap[0].emissionsPreliminary.length -1]
        objectGrid.priceByChap =  totalPassByCap[0].unitPrice
      }
      else {
        
        //ES LARGOMETRAJE - AGREGAR EL NUMERO DE PASADA
        if (this.itemObject.emissionsPreliminary.includes("No emitido")) {
          this.itemObject.emissionsPreliminary[0] = programDate
          objectGrid.priceByPass =  this.itemObject.broadcastPrice[this.itemObject.emissionsPreliminary.length -1] 
          objectGrid.priceByChap =  this.itemObject.unitPrice
        }
        else {
          let includesDay = this.itemObject.emissionsPreliminary.filter(function(item) {
            return item == programDate
          }) 
          if (includesDay.length == 0) {
            this.itemObject.emissionsPreliminary.push(programDate)
            objectGrid.priceByPass =  this.itemObject.broadcastPrice[this.itemObject.emissionsPreliminary.length -1] 
            objectGrid.priceByChap =  this.itemObject.unitPrice
          }
        }
      }
    
      if(chapterOriginal != '' && chapterOriginal != null ) {
        //eliminar el capitulo 
        this.restEmisions( chapterOriginal, programDate )
      }
    },
    verifyNumberPass (dataOfDays) {
      
      dataOfDays.map(( daySelect ) => {
        this.originalInfoOfGrid.map(( initialItem ) => {
          if( initialItem.completeDate == daySelect.completeDate ) {
            daySelect.chapters.map((chapter, i, arr) => {
              
              if ( initialItem.chapters[i] && chapter.numChapter !== initialItem.chapters[i].numChapter ) {
                this.restPassConsumedMaterial( chapter.numChapter, initialItem.chapters[i].numChapter, daySelect.programDate, chapter )
              }
              else if ( initialItem.chapters[i] == undefined  ) {
                this.restPassConsumedMaterial( chapter.numChapter, '', daySelect.programDate, chapter )
              }
            })
            if ( initialItem.chapters.length >  daySelect.chapters.length ) {
              for ( let index = daySelect.chapters.length; index < initialItem.chapters.length; index++ ) {
                this.restEmisions( initialItem.chapters[index].numChapter, daySelect.programDate )
              }
            }
          }
        })
      })
    },
    isMaterialCanned(stringMaterialType) {
      if (stringMaterialType == "Enlatado") {
        return true
      }
      else {
        return false
      }
    },
    cleanArrcheckCrosses() {
      this.arrCheckCrosses = []
      this.crushedPrograms = []
    },
    reducingSchedules(programs) {
      let allPrograms = this.filtrandoMaterialesDiferentesALosActuales(this.newGrid.grid.fullGrid.preliminaryPrograms, this.newGrid.cardsData )
      console.log(allPrograms, 'allPrograms reducingSchedules')
      this.arrCheckCrosses.map((el, i, arr) => {
        let filterByDay = allPrograms.filter( m => {
          return m.completeDate == el.completeDate
        });

        filterByDay.map((ello, i, arr) => {
          
          if(el.completeDate == ello.completeDate && el.time == 'Todo el horario' && el.geminisCodeProgram == ello.geminisCodeProgram) {
            allPrograms.splice(allPrograms.indexOf(ello), 1)
          }
          else if (el.completeDate== ello.completeDate && el.geminisCodeProgram == ello.geminisCodeProgram && el.time !== 'Todo el horario' ) {
            ello.scheduleStartHour = el.crossingTimes.scheduleStartHour
            ello.scheduleStartMin = el.crossingTimes.scheduleStartMin
            ello.scheduleEndHour = el.crossingTimes.scheduleEndHour
            ello.scheduleEndMin = el.crossingTimes.scheduleEndMin
          } 
        })
      })
      
      this.programasModifyCrushed = allPrograms
      // this.sendProgramation(this.newGrid)
      // let dataOfDays = []
      // const {cardsData} = programs

      // cardsData.map((el, i) => {
      //   el.dailyProgramDate = programs.arrOfDays[i].numberOfDay.toString()
      //   if(el.materialTitle !== '' && el.codMaterial !== '') {
      //     // el.nameView = 'programGrid'
      //     dataOfDays.push(el)
      //   }
      // })

      let dataPrograms = this.arrCheckCrosses.length > 0 ? this.programasModifyCrushed: programs.grid.fullGrid.preliminaryPrograms
      this.updateGridWeek(programs, dataPrograms, programs.cardsData )
    },
    filtrandoMaterialesDiferentesALosActuales(fullGrid, newGrid) {
      let allPrograms = fullGrid.filter(friend => {
        let res = newGrid.find((following) => {
          return following.geminisCodeProgram == friend.geminisCodeProgram;
        });
        return res == undefined;
      })
      return allPrograms
    },
    evaluedDataSet() {
      let response
      // const {signalsSelected} = this.newGrid.cardsData[0]
      // if(signalsSelected && signalsSelected.length > 0) {
      //   response = this.changeSignals.length > 0 ? this.changeSignals : signalsSelected
      // } else {
        response = this.newGrid.programInfo.checkedSignals
      // }
      return response
    },
    checkCrosses () {
      let continueValidation = this.sendProgramation(this.newGrid)
      let historyTime
      let checkSignals = this.evaluedDataSet()
      let signalsCodeSelected = (this.channelTransmition === 'AMÉRICA TV')?this.arrSignalsCode:['NX']
      // this.validTextEndModal()
      if(continueValidation !== false) {
        if(this.newGrid.grid.weekDate !== 'Week not found') {
          let allPrograms = this.filtrandoMaterialesDiferentesALosActuales(this.newGrid.grid.fullGrid.preliminaryPrograms, this.newGrid.cardsData)
          continueValidation.dataOfDays.map((el, i , arr) => {
            this.$set(el, "signalsSelected", checkSignals)
            this.$set(el, "signalsCodeSelected", signalsCodeSelected)

            this.$set(el, "userName", this.userName)
            this.$set(el, "timeStart", convertHourDate(new Date(el.programDate), el.scheduleStartHour, el.scheduleStartMin))
            this.$set(el, "timeEnd", convertHourDate(new Date(el.programDate), el.scheduleEndHour, el.scheduleEndMin))
            
            // historyTime = {
            //   timeStart: el.timeStart ? el.timeStart : convertHourDate(new Date(newGrid.arrOfDays[i].programDate), el.scheduleStartHour, el.scheduleStartMin),
            //   timeEnd: el.timeEnd ? el.timeEnd : convertHourDate(new Date(newGrid.arrOfDays[i].programDate), el.scheduleEndHour, el.scheduleEndMin)
            // }

            // this.$set(el, 'historyTime', historyTime)
            // FILTRA LOS PROGRAMAS QUE HAN SIDO PROGRAMADOS EL MISMO DIA
            let filterByDay = allPrograms.filter( m => {
              return m.completeDate == el.completeDate
            });

            // COMPARAR HORARIOS
            // obteniendo la hora de inicio y fin del programa actual
            let startTime = Number(el.scheduleStartHour + el.scheduleStartMin)
            let endTime = el.scheduleEndHour == '00' ? Number('24' + el.scheduleEndMin) : Number(el.scheduleEndHour + el.scheduleEndMin)
            let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(el.programDate, el.scheduleStartHour, el.scheduleStartMin), el.programDate, 'start' )
            let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(el.programDate, el.scheduleEndHour, el.scheduleEndMin), el.programDate, 'end' ) 

            filterByDay.map((ella, i, arr ) => {   
            // obteniendo la hora de inicio del programa con el q se cruza - 03:45 - seria 345 (suma horas + minutos)
              let allStartTime = Number(ella.scheduleStartHour + ella.scheduleStartMin) 
              let allEndTime =  ella.scheduleEndHour == '00' ? Number('24' + ella.scheduleEndMin) : Number(ella.scheduleEndHour + ella.scheduleEndMin)
              
              // obteniendo la hora de fin del programa con el q se cruza --             
              // nuevo formato de las horas de  inicio y fin del los programa con los que se cruzaria - 03:45
              let startTimeFormat  = '00:' + ella.scheduleStartHour + ':' + ella.scheduleStartMin
              let endTimeFormat = '00:' + ella.scheduleEndHour + ':' + ella.scheduleEndMin
              // nuevo formato de las horas de  inicio y fin del programa actual - 03:45
              let startFormat = '00:' + el.scheduleStartHour + ':' + el.scheduleStartMin
              let endFormat = '00:' + el.scheduleEndHour + ':' + el.scheduleEndMin

              let endTimeFormatX = `${ella.scheduleEndHour}:${ella.scheduleEndMin}:00`
              let startTimeFormatX  = ella.scheduleStartHour + ':' + ella.scheduleStartMin + ':00'
              let endFormatX = `${el.scheduleEndHour}:${el.scheduleEndMin}:00`
              let startFormatX = `${el.scheduleStartHour}:${el.scheduleStartMin}:00`

              let timeStartAllProgram = convertFormatDayForCrusses( convertHourDate(ella.programDate, ella.scheduleStartHour, ella.scheduleStartMin), ella.programDate, 'start' )
              let timeEndAllProgram = convertFormatDayForCrusses( convertHourDate(ella.programDate, ella.scheduleEndHour, ella.scheduleEndMin), ella.programDate, 'end' )

              if (  timeStartProgramCardsData <  timeEndAllProgram  && timeEndProgramCardsData >  timeStartAllProgram ) {
                // Obtengo el primer rango en el que se encuentra el horario de inicio
                if ( timeStartProgramCardsData > timeStartAllProgram && timeStartProgramCardsData < timeEndAllProgram ) {                  
                  if ( allEndTime - allStartTime === allEndTime - startTime ) {
                    this.arrCheckCrosses.push(
                      { title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: 'Todo el horario', completeDate: ella.completeDate, newProgram: el.programGridTitle }
                      )
                  }
                  else if (timeEndProgramCardsData > timeStartAllProgram && timeEndProgramCardsData <= timeEndAllProgram ) {
                    let newHoursEnd = startFormat.split(':')
                    let newHoursStart = startTimeFormat.split(':')

                    let newHoursEnd2 = endTimeFormat.split(':') 
                    let newHoursStart2 = endFormat.split(':')

                    this.arrCheckCrosses.push({ crushedMidle: true, title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: restTimes(endTimeFormat, startFormat), completeDate: ella.completeDate, newProgram: el.programGridTitle,
                    chapters: ella.chapters, dailyCuttingProgram: ella.dailyCuttingProgram, crossingTimes: { timeStart: convertHourDate(new Date(el.programDate), newHoursStart[1], newHoursStart[2]), timeEnd: convertHourDate(new Date(el.programDate), newHoursEnd[1], newHoursEnd[2] ),  scheduleStartHour: newHoursStart[1] , scheduleStartMin: newHoursStart[2], scheduleEndHour: newHoursEnd[1], scheduleEndMin: newHoursEnd[2], scheduleStartHour2: newHoursStart2[1], scheduleStartMin2: newHoursStart2[2],   scheduleEndHour2: newHoursEnd2[1], scheduleEndMin2: newHoursEnd2[2], timeStart2: convertHourDate(new Date(el.programDate), newHoursStart2[1], newHoursStart2[2]), timeEnd2: convertHourDate(new Date(el.programDate), newHoursEnd2[1], newHoursEnd2[2] ) } })
                    
                  }
                  else {
                    let newHoursEnd = startFormat.split(':')
                    let newHoursStart = startTimeFormat.split(':')
                    this.arrCheckCrosses.push({ crushedMidle: false, title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: restTimes(endTimeFormat, startFormat), completeDate: ella.completeDate, newProgram: el.programGridTitle,
                    chapters: ella.chapters, dailyCuttingProgram: ella.dailyCuttingProgram, crossingTimes: { timeStart:  convertHourDate(new Date(el.programDate), newHoursStart[1], newHoursStart[2]), timeEnd: convertHourDate(new Date(el.programDate), newHoursEnd[1], newHoursEnd[2] ),  scheduleStartHour: newHoursStart[1] , scheduleStartMin: newHoursStart[2], scheduleEndHour: newHoursEnd[1], scheduleEndMin: newHoursEnd[2] } })
                  }
                }
                // Obtengo los rangos intermedios
                else if ( timeStartProgramCardsData < timeStartAllProgram && timeEndProgramCardsData >= timeEndAllProgram ) {
                  this.arrCheckCrosses.push({ crushedMidle: false, title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: 'Todo el horario', completeDate: ella.completeDate, newProgram: el.programGridTitle })
                }
                // Obtengo el último rango en el que se encuentra el horario de fin
                else if ( timeEndProgramCardsData > timeStartAllProgram && timeEndProgramCardsData <= timeEndAllProgram ) {
                  if (allEndTime - endTime  === 0) {
                    this.arrCheckCrosses.push({title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: 'Todo el horario', completeDate: ella.completeDate, newProgram: el.programGridTitle }) 
                  }
                  else {
                    let newHoursEnd = endTimeFormat.split(':') 
                    let newHoursStart = endFormat.split(':')
                    this.arrCheckCrosses.push({ crushedMidle: false, title: ella.programGridTitle, time: restTimes(endFormat, startTimeFormat), geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, completeDate: ella.completeDate, chapters: ella.chapters, dailyCuttingProgram: ella.dailyCuttingProgram,  crossingTimes: { timeStart:  convertHourDate(new Date(el.programDate), newHoursStart[1], newHoursStart[2]), timeEnd: convertHourDate(new Date(el.programDate), newHoursEnd[1], newHoursEnd[2] ), scheduleStartHour: newHoursStart[1] , scheduleStartMin: newHoursStart[2], scheduleEndHour: newHoursEnd[1], scheduleEndMin: newHoursEnd[2] }})
                  }
                }
                else if (startTimeFormatX ==  startFormatX && timeStartProgramCardsData < timeEndAllProgram ) {
                  this.arrCheckCrosses.push(
                  { title: ella.programGridTitle, geminisCodeProgram: ella.geminisCodeProgram, signalsCodeSelected: el.signalsCodeSelected, programDate: ella.programDate, time: 'Todo el horario', completeDate: ella.completeDate, newProgram: el.programGridTitle }
                  )
                }
              }      
            })      
          })
          
          console.log(this.arrCheckCrosses, 'this.arrCheckCrosses')
          if(this.arrCheckCrosses.length > 0) {
            this.checkCrossesModal = true
          } else {
            let programs = this.arrCheckCrosses.length > 0 ? this.programasModifyCrushed: this.newGrid.grid.fullGrid.preliminaryPrograms
            this.updateGridWeek(this.newGrid, programs, continueValidation.dataOfDays)
          }
        } else {
          
          continueValidation.dataOfDays.map((el) => {
            this.$set(el, "signalsSelected", checkSignals)
            this.$set(el, "signalsCodeSelected", signalsCodeSelected)
            this.$set(el, "userName", this.userName)
            this.$set(el, "timeStart", convertHourDate(new Date(el.programDate), el.scheduleStartHour, el.scheduleStartMin))
            this.$set(el, "timeEnd", convertHourDate(new Date(el.programDate), el.scheduleEndHour, el.scheduleEndMin))
            historyTime = {
              timeStart: el.timeStart ? el.timeStart : convertHourDate(new Date(el.programDate), el.scheduleStartHour, el.scheduleStartMin),
              timeEnd: el.timeEnd ? el.timeEnd : convertHourDate(new Date(el.programDate), el.scheduleEndHour, el.scheduleEndMin)
            }
            this.$set(el, 'historyTime', historyTime)
          })
          this.saveNewGridWeek(this.newGrid, continueValidation.dataOfDays)        
        }
      }
    },
    getUniPrice ( allChapterProgram ) { 
           
      allChapterProgram.map((ella ) => {      
        let infoCap = this.itemObject.numChapters[0].arrOfChapters.filter(function(item) {
          return item.id == Number(ella.numChapter)
        })
            
        ella.priceByChap = infoCap[0].unitPrice
        ella.priceByPass = infoCap[0].unitPrice
      })    
    },

    // METHODS FOR GRID PRELIMINARY
    gettingUsername () {
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
  
    getMaterialSelected(codigoMaterial) {
      console.log(codigoMaterial, 'codigoMaterial')
      HTTP.get('materials/'+ codigoMaterial)
      .then(res => {
        // console.log(res, 'res')
        this.itemObject = res.data.material
        console.log(this.itemObject, 'this.itemObject')
        this.nombreDelProveedor = this.itemObject.providerName
        this.positionMat = this.itemObject.contractPosition
        this.verifyPassExcedent(this.itemObject)
      })
      .catch(err => console.log(err))
    },
    verifyPassExcedent (itemObject) {
      if (itemObject) {
        if (!this.validateCannedNext(itemObject)) {
          this.cleanCards(this.newGrid.cardsData)
        }
      }
    },
    cleanCards (cards) {
      cards.map((day) => {
        let objChapter = {
          numChapter: "",
          rerun: false,
          estreno: false,
          ongoing: false,
          season: "",
          seasonInfo: "",
          // status: ""
        }
        // CUANDO NO ENCUENTRA COINCIDENCIAS LIMPIA EL OBJETO
        day.dailyCuttingProgram = []
        day.codMaterial = ''
        day.isShowTemporadas = false
        day.materialTitle = ''
        day.material = ''
        day.materialReferencia = {}
        day.chapters = [objChapter]
        day.materialExisting = ''
        day.materialHasChapter = ''
      })
    },
    validateCannedNext (material) {
      let isCanned = this.isMaterialCanned(material.stringMaterialType)
      if ( isCanned ) {
        if (!this.verifyPass(material)) {
          this.notHaveSignalForProgram = true
          this.textNotHaveSignalForProgram = 'El material no tiene pasadas'
          return false
        }
        else {
          return true
        }
      }
      else {
        return true
      }
    },
    verifyPass (material) {
      if (material.numChapters.length == 0) {
        let totalPass = Number(material.totalPass)
        let pasadasConsumidas = Number(material.emissionsPreliminary.length)
        if ( totalPass > pasadasConsumidas ) {
          return true
        }
        else {
          return false
        }
      }
      else {
        let arrayDeCapitulos = material.numChapters[0].infoByChapter
        let objChapter = {  numChapter: null, rerun: false, estreno: false, ongoing: false, season: "", seasonInfo: "" }
        this.newGrid.cardsData.map((programByDay, index) => {
          let arrayDeIndices = []
          programByDay.chapters.map((chapter, i, arr) => {
            if ( chapter.numChapter != null ) {
              let filterCap = arrayDeCapitulos.filter( m => m.chapter == chapter.numChapter )
              let programDayIncludesInEmision = filterCap[0].emissionsPreliminary.includes(programByDay.programDate)
              if (!programDayIncludesInEmision && filterCap[0].specificPass <=  filterCap[0].emissionsPreliminary.length ) {
                console.log('se consumio las pasadas del capitulo')
                arrayDeIndices.push(i)
              }
            }
          })
          if (arrayDeIndices.length > 0) {
            arrayDeIndices.map((position, i, arr) => {
              if (i == (arr.length - 1) ) {
                this.$set(this.newGrid.cardsData[index], 'chapters', [objChapter])
              }
              else {
                programByDay.chapters.splice( position, 1 ) 
              }
            })
          }
        })
        return true
      }
    },
    programObj () {            
      let grid = JSON.parse(this.$localStorage.get("gridPayload"));   
      this.codigoMaterial = grid.codMaterial
      let cards = grid.cardsData;
      let filtArr = []

      filtArr = cards.filter(function(item) { 
        return item !== 0
      })

      grid.cardsData = filtArr;
      grid.cardsData.map((el, i, arr ) => {
        this.$set(el, "isModification", false )
      })

      if ( grid.cardsData[0].materialExisting == "Si" && grid.cardsData[0].idMaterialRef) {
        this.getMaterialSelected(grid.cardsData[0].idMaterialRef)
      }
      grid.cardsData.map((e) => {
        // console.log("e", e)
        const materialType = e
        const _materialTypeString = typeof materialType === 'string' ? materialType : materialType.toString()
        if(_materialTypeString === 'Afiliación,Televisa') {
          let transform = _materialTypeString.split(',')
          this.$set(e, 'materialType', transform)
        } else {
          this.$set(e, 'materialType', [_materialTypeString])
        }
      })
      
      // console.log(grid, 'grid 111')
      this.newGrid = grid
      this.arrSignalsCode = grid.programInfo.signalsCode
      this.isHaveAllSignalProgram = grid.programInfo.checkedSignals
      this.$set(this.newGrid, "userName", this.userName )
      console.log(grid, 'grid 22222')
      // this.newGrid = grid

      const {programInfo} = grid
      if(programInfo.priceForDay && programInfo.priceForDay !== '') {
        this.priceForDay = programInfo.priceForDay
      }
      console.log(this.priceForDay, 'this.priceForDay')
    },
    getInitialData() {
      let grid = JSON.parse(this.$localStorage.get("gridPayload"))
      let cards = grid.cardsData;
      let filtArr = []

      filtArr = cards.filter(function(item) { 
        return item !== 0
      })

      this.originalInfoOfGrid = filtArr
      if(filtArr && filtArr.length > 0) {
        this.showActorsEdit(filtArr[0])
      }
    },
    hasChapter (day) {
      if (day.materialHasChapter == 'Si') {
        day.isShowTemporadas = true
      } else {
        day.isShowTemporadas = false
      }
    },
    deleteInfoMaterial (day, value) {
      day.materialTitle = ''
      day.codMaterial = ''
      if(this.priceForDay && this.priceForDay !== null) {
        // console.log(day, 'day')
        // console.log(this.priceForDay, 'this.priceForDay deleteInfoMaterial')
        day.chapters.map((e) => {
          e.priceByPass = this.priceForDay
        })
      }
    },
    isMaterialExist(value) {
      return value === 'No' ? false : true
    },
    cleanDataChapter(day) {
      let objChapter = {
        numChapter: "",
        rerun: false,
        estreno: false,
        ongoing: false,
        season: "",
        seasonInfo: ""
      }
      // CUANDO NO ENCUENTRA COINCIDENCIAS LIMPIA EL OBJETO
      day.dailyCuttingProgram = []
      day.codMaterial = ''
      day.isShowTemporadas = false
      day.materialTitle = ''
      day.material = ''
      day.materialReferencia = {}
      day.chapters = [objChapter]
      this.pricePassMovie = null
    },
    // LIMPIA LA DATA SI LOS INPUTS ESTABAN LLENOS ANTERIORMENTE Y AHORA ESTAN VACIO
    verifyIfHasContent(day) {
      if(day.materialTitle == ''){
        this.cleanDataChapter(day)
      }
    },
    showMaterial(oneMaterial, index, day) {
      
      this.newGrid.cardsData[index].materialTitle = oneMaterial[0].listTitle
      this.newGrid.cardsData[index].codMaterial = oneMaterial[0].codMaterial
      this.newGrid.cardsData[index].idMaterialRef = oneMaterial[0]._id ? oneMaterial[0]._id : oneMaterial[0].__id 

      this.itemObject = oneMaterial[0]
      const { listTitle, codMaterial, numChapters, __id} = oneMaterial[0]
      const elemSelect = this.newGrid.cardsData[index]
      let objChapter = {
        numChapter: "",
        rerun: false,
        estreno: false,
        ongoing: false,
        season: "",
        seasonInfo: "",
        priceByPass: this.pricePassMovie != null ? this.pricePassMovie : this.priceForDay 
      }

      elemSelect.chapters = [objChapter]
      elemSelect.materialTitle = listTitle
      elemSelect.codMaterial = codMaterial
      // elemSelect.material = __id
      elemSelect.isShowTemporadas = numChapters.length > 0 ? true : false
      elemSelect.chapters[0].season = numChapters.length > 0 ? numChapters[0].season : ''
      
      this.showActorsForSelect(this.itemObject, day)
      this.showNameProviderAndPositionInContract(this.itemObject, day, index)
      this.setDataInItemPassSelect(oneMaterial[0])
    },
    showMaterialFindByName ( itemObject, index, day) {
      this.newGrid.cardsData[index].materialTitle = this.itemObject.listTitle
      this.newGrid.cardsData[index].codMaterial = this.itemObject.codMaterial
      this.newGrid.cardsData[index].idMaterialRef = this.itemObject._id ? this.itemObject._id : this.itemObject.__id 
      this.daySelected = day.completeDate
      let grid = this.newGrid
      
      // DATA
      const {__id, codMaterial, listTitle } = this.itemObject
      let objChapter = {
        numChapter: "",
        rerun: false,
        estreno: false,
        ongoing: false,
        season: "",
        seasonInfo: "",
        priceByPass: this.pricePassMovie != null ? this.pricePassMovie : this.priceForDay 
      }
      day.chapters = [objChapter]
      // day.material = __id
      day.materialTitle = listTitle
      day.codMaterial = codMaterial
      
      // VALIDA SI EL MATERIAL SELECCIONADO TIENE CAPITULOS
      this.newGrid.cardsData[index].isShowTemporadas = (this.itemObject.numChapters.length > 0) ? true : false
      this.newGrid.cardsData[index].chapters[0].season = (this.itemObject.numChapters.length > 0) ? this.itemObject.numChapters[0].season : ''
      this.showActorsForSelect(this.itemObject, day)
      this.showNameProviderAndPositionInContract(this.itemObject, day, index)
    },
    async loadAllPrograms (value) {
      const {date,code,title}= value
      let prevDate =  date !== null ? moment(date, "DD-MM-YYYY") : null
      let dateSend = date !== null ? new Date(prevDate).getTime() : null
      const channelTransmition = (this.$localStorage.get('channelTransmition')) == 'AMÉRICA TV' ? 'América TV' : (this.$localStorage.get('channelTransmition')).toLowerCase()
      let res = await HTTP.post('materials/filter',{
        channel:channelTransmition,
        listTitle:title,
        codMaterial:code,
        filtroMat: true,
        dateSend,
      })
      return res.data.docs
    },
    querySearch (queryString, cb) {
      // this.loadAllPrograms(null,queryString)
      // .then(res=>cb(res))
      this.loadAllPrograms({date:null,code: null,title:queryString})
      .then(res=>{
        console.log(res, 'res----querySearch')
        return cb(res)
        })
    },
    createFilter (queryString) {
      return (link) => {
        return (modifyText(link.listTitle).indexOf(modifyText(queryString)) === 0);
      }
    },
    verifyIfHasContentAll(day, data) {
      if(day.materialTitle == '' || day == ''){
        data.map((e) => {
          this.cleanDataChapter(e)
        })
        this.itemObject = {}
      }
    },
    // METODO PARA SELECCIONAR MATERIAL POR CODIGO
    findMaterialByCode(index, day) {
      this.daySelected = day.completeDate
      let selectDayNewGrid = this.newGrid.arrOfDays[index].programDate.split('T')
      let dayTransform = moment(selectDayNewGrid[0], "YYYY-MM-DD").format("DD-MM-YYYY")
      const code = this.newGrid.cardsData[index].codMaterial;
      if (code) {
        this.loadAllPrograms({date:dayTransform,code,title:null})
        .then(async (res)=>{
          console.log({res})
          if(res.length > 0) {
            if ( res[0].contractCode != '' && res[0].stringMaterialType == "Enlatado" && res[0].codeTypeContent == "010" ) {
              let codMaterial = res[0].geminisCode
              let contractCode =  res[0].geminisCodeContract ? res[0].geminisCodeContract : res[0].contractCode
              console.log( codMaterial, 'codMaterial' )
              console.log( contractCode, 'contractCode' )
              let infoPrice = await HTTP.get(`contracts/contractCode/${contractCode}/geminisCodeMaterial/${codMaterial}/numchapter/1/getPricePass/${dayTransform}`)
               console.log({infoPrice})
              this.pricePassMovie = infoPrice.data
              this.$set(day.chapters[0], 'priceByPass', infoPrice.data)
              console.log(this.pricePassMovie, 'response this.pricePassMovie')
            }
            
            this.showMaterial( res, index, day)        
          } 
          else {
            this.cleanDataChapter(day)
          }
        })
      }
    },
    // METODO PARA SELECCIONAR MATERIAL POR NOMBRE DE MATERIAL
   async findMaterialByName(index, day) {
      let selectDayNewGrid = this.newGrid.arrOfDays[index].programDate.split('T')
      let dayTransform = moment(selectDayNewGrid[0], "YYYY-MM-DD").format("DD-MM-YYYY")
      if (this.itemObject ) {
        if ( this.itemObject.contractCode != '' && this.itemObject.stringMaterialType == "Enlatado" && this.itemObject.codeTypeContent == "010" ) {
          let codMaterial = this.itemObject.geminisCode
          let contractCode = this.itemObject.contractCode
          let infoPrice = await HTTP.get(`contracts/contractCode/${contractCode}/geminisCodeMaterial/${codMaterial}/numchapter/1/getPricePass/${dayTransform}`)       
          this.pricePassMovie = infoPrice.data
          console.log(this.pricePassMovie, 'response this.pricePassMovie')
          this.$set(day.chapters[0], 'priceByPass', infoPrice.data)
        }
        this.showMaterialFindByName(this.itemObject, index, day)
      }
    },
    addChapter(i, index, chapter) {
      let newChapter = {numChapter: "", season: chapter.season, seasonInfo: "", rerun: false, estreno: false, ongoing: false};
      this.newGrid.cardsData[index].chapters.splice(i+1, 0, newChapter);
    },
    deleteChapter(i, index) {
      this.newGrid.cardsData[index].chapters.splice(i, 1);
    },
    copyButton(index, day) {
      
      this.modalCopy = true
      this.indexToCopy = index

      let setNumbChap = day.chapters.map((e) => {
        const {numChapter, ...rest} = e
        return {
          numChapter: '',
          ...rest
        }
      })

      let objDayToCopy = {
        chapters: setNumbChap,
        materialTitle: day.materialTitle,
        codMaterial: day.codMaterial,
        materialExisting: day.materialExisting,
        materialHasChapter: day.materialHasChapter,
        materialType: day.materialType,
        typeOfContent: day.typeOfContent,
        isShowTemporadas: day.isShowTemporadas,
        classification: day.classification,
        codeFeatureFilm: day.codeFeatureFilm,
        theyAreVoiceActors: day.theyAreVoiceActors,
        firstActor: day.firstActor,
        secondActor: day.secondActor,
        scheduleStartHour: day.scheduleStartHour,
        scheduleStartMin: day.scheduleStartMin,
        scheduleEndHour: day.scheduleEndHour,
        scheduleEndMin: day.scheduleEndMin
      }
      this.$localStorage.set('dayToCopy', JSON.stringify(objDayToCopy))
    },
    saveCopy() {
      let grid = this.newGrid
      for(let x=0; x<grid.cardsData.length; x++){
        if(x>this.indexToCopy){
          let data = JSON.parse(this.$localStorage.get("dayToCopy"))
          // console.log(data, 'data')
          grid.cardsData[x].chapters = data.chapters
          grid.cardsData[x].materialTitle = data.materialTitle
          grid.cardsData[x].codMaterial = data.codMaterial
          grid.cardsData[x].materialExisting = data.materialExisting
          grid.cardsData[x].materialHasChapter = data.materialHasChapter
          grid.cardsData[x].materialType = data.materialType
          grid.cardsData[x].typeOfContent = data.typeOfContent
          grid.cardsData[x].isShowTemporadas = data.isShowTemporadas
          grid.cardsData[x].classification = data.classification
          grid.cardsData[x].codeFeatureFilm = data.codeFeatureFilm
          grid.cardsData[x].theyAreVoiceActors = data.theyAreVoiceActors
          grid.cardsData[x].firstActor = data.firstActor
          grid.cardsData[x].secondActor = data.secondActor
          grid.cardsData[x].scheduleStartHour = data.scheduleStartHour
          grid.cardsData[x].scheduleStartMin = data.scheduleStartMin
          grid.cardsData[x].scheduleEndHour = data.scheduleEndHour
          grid.cardsData[x].scheduleEndMin = data.scheduleEndMin
        }
      }
      this.modalCopy = false
    },
    returnToGrill (){
      this.$localStorage.set('programedProgram', JSON.stringify(this.newGrid))
      this.$router.push({name: 'gridContentPreliminary', params: {type: this.typeChannel, day: this.$route.params.day}})
    },
    returnPage() {
      let daySelect = this.$route.params ? this.$route.params.day : null
      this.$router.push({name: 'gridContentPreliminary', params: {type: this.typeChannel, day: daySelect}})
      this.returnButtonModal = true
    },
    sendProgramation(programObj) {
      let dataOfDays = []
      const {cardsData} = programObj
      this.$localStorage.set('lastProgramActualizate', JSON.stringify(programObj.programInfo))
    
      cardsData.map((el, i) => {
        const dayString = el.completeDate.split(' ')[1]
        programObj.arrOfDays.map((day)=>{
          if(day.numberOfDay.toString() == dayString){
            el.dailyProgramDate = day.numberOfDay.toString()
            el.programDate = day.programDate
          }
        })        

        if(el.materialTitle !== '') {
          dataOfDays.push(el)
        }
      })

      // VALIDA SI HAY POR LO MENOS 1 DIA LLENO
      if(dataOfDays.length == 0){
        this.noInfoToSave = true
        return false 
      }

      return {programObj, dataOfDays}

    },
    updateGridWeek(programObj, programs, dataOfDays) {  
      
      
      console.log(this.itemObject, 'this.itemObject')
     if ( Object.keys(this.itemObject).length !== 0 ) {
       
        let isCanned = this.isMaterialCanned(this.itemObject.stringMaterialType) && this.itemObject.codMaterial.includes('M')
        if ( isCanned ) {
          // return console.log('encontro clave keys y va a actualizar :()');
          this.verifyNumberPass(dataOfDays)
          let id = this.itemObject._id == undefined ? this.itemObject.__id : this.itemObject._id
          let valor = this.itemObject.numChapters.length > 0 ? this.itemObject.numChapters : this.itemObject.emissionsPreliminary
          let propiedad = this.itemObject.numChapters.length > 0  ? "numChapters" : "emissionsPreliminary"

          HTTP.patch('materials/update/' + id, 
          [{ propName: propiedad, value: valor } ])
          .then(data => {
            // this.$store.dispatch('getData', 'materials/allMaterials/allMaterials')
          })
          .catch(err => console.log(err))
        }

        

        console.log(this.itemObject, 'this.itemObject')

        dataOfDays.map(( program ) => {        
          program.providerCode = this.itemObject.providerCode,
          program.classification = this.itemObject.classification,
          program.materialType = this.itemObject.materialType[0],
          program.season = this.itemObject.numChapters.length == 0 ? null : program.chapters[0].season,
          program.typeOfContent = this.itemObject.typeOfContent,
          program.materialHasChapter = this.itemObject.numChapters.length == 0 ? 'No': 'Si',
          program.chapters[0].priceByPass  = this.pricePassMovie ? this.pricePassMovie : program.chapters[0].priceByPass
        })
      }
      else {
        dataOfDays.map(( program ) => {
          program.season = program.chapters[0].season
        })
      }

      // PROGRAMAS GUARDADOS LA MISMA SEMANA, PERO DISTINTOS PROGRAMAS AL SELECCIONADO
      let cleanPrograms = []
      cleanPrograms = programs.filter(function(item) {
        return item.geminisCodeProgram !== programObj.programInfo.geminisCode
      })

      /*Si se selecciono actores */
      // dataOfDays = this.setActorsInDataOfDays(dataOfDays)

      /* ELIMINAR DÍAS QUE NO SE REGISTRA DATA */
      dataOfDays = dataOfDays.filter(data=>{
        let existDay =  this.newGrid.cardsData.find(el=>el.completeDate==data.completeDate);
        if(existDay!=null || existDay!=undefined){
          if(existDay.materialTitle!='' && (existDay.materialExisting != undefined)){
            return true;
          }else{
            return false;
          }
        }else{
          return false;
        }
      })

      console.log(dataOfDays, 'dataOfDays dataOfDays')

      /*UPDATE EN MONGODB */
      HTTP.patch(`grid/update/${ programObj.grid._id }`,
        [
          { propName: "preliminaryPrograms", value: dataOfDays.concat(cleanPrograms) }
        ]
      ).then( res => {
        this.modalUpdateToGoBack = true
      })
      .catch(err => console.log(err))
    },
    saveNewGridWeek(programObj, dataOfDays) {
      
      
      if ( Object.keys(this.itemObject).length !== 0 ) {
        let isCanned = this.isMaterialCanned(this.itemObject.stringMaterialType) && this.itemObject.codMaterial.includes('M')
        if ( isCanned ) {
          this.verifyNumberPass(dataOfDays)
          let id = this.itemObject._id == undefined ? this.itemObject.__id : this.itemObject._id
          let valor = this.itemObject.numChapters.length > 0 ? this.itemObject.numChapters : this.itemObject.emissionsPreliminary
          let propiedad = this.itemObject.numChapters.length > 0  ? "numChapters" : "emissionsPreliminary"

          console.log(valor, 'valor')
          console.log(propiedad, 'propiedad')

          HTTP.patch('materials/update/' + id, 
          [{ propName: propiedad, value: valor } ])
          .then(data => {
            // this.$store.dispatch('getData', 'materials/allMaterials/allMaterials')
          })
          .catch(err => console.log(err))
        }


        dataOfDays.map(( program ) => {
          program.providerCode = this.itemObject.providerCode,
          program.classification = this.itemObject.classification,
          program.materialType = this.itemObject.materialType,
          program.unitPrice = this.itemObject.unitPrice
          program.season = this.itemObject.numChapters.length == 0 ? null : this.itemObject.numChapters[0].season,
          program.typeOfContent = this.itemObject.typeOfContent,
          program.materialHasChapter = this.itemObject.numChapters.length == 0 ? 'No': 'Si',
          program.chapters[0].priceByPass  = this.pricePassMovie ? this.pricePassMovie : program.chapters[0].priceByPass
        })

      }
      else {
        
        dataOfDays.map(( program ) => {
          program.season = program.chapters[0].season
        })
      }
      /*Si se selecciono actores */
      // dataOfDays = this.setActorsInDataOfDays(dataOfDays)
      
      let gridToPost = {
        week: programObj.dateString,
        approvedWeek: false,
        dateStart : programObj.dateStart,
        dateEnd: programObj.dateEnd,
        preliminaryPrograms: dataOfDays,
        programs: []
      }


      console.log(gridToPost, 'gridToPost post')

      // POST EN MONGODB

      HTTP.post('grid/saveNewGrid', gridToPost)
      .then(res => {
        this.modalToGoBack = true
      })
      .catch(err => console.log(err)); 
    },
    handleSelect (item) {
      this.itemObjectCopy = Object.assign({}, item)
      this.itemObject = item
      this.setDataInItemPassSelect(item)
    },
    setDataInItemPassSelect(item) {
      const {numChapters, geminisCode, stringMaterialType, codMaterial} = item
      let isMatCreatedForIngrid = codMaterial.includes('M')
      let conditionalTypeMaterial = stringMaterialType === 'Enlatado' ? true : false
      if(numChapters && numChapters.length > 0 && conditionalTypeMaterial && isMatCreatedForIngrid) {
        const {numChapters, totalPass} = item
        const {arrOfChapters, chapters, infoByChapter} = numChapters[0]      
        let arrPassOfChap = arrOfChapters.map((e) => {
          const {id, specificPass} = e
          let filterPassConsumed = infoByChapter.filter((e) => e.chapter == id)[0]
          let passChap = filterPassConsumed.pastConsumed ? Number(specificPass) - filterPassConsumed.pastConsumed : Number(specificPass)
          return {
            chapter: id,
            passForChap: passChap
          }
        })
        let obj = {
          geminisCode,
          arrPassOfChap
        }
        // console.log(obj.arrPassOfChap, 'arrPassOfChap arrPassOfChap ')
        if(geminisCode !== this.itemPassSelect.geminisCode) {
          this.itemPassSelect = obj
        }
      }
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    showActorsForSelect(value, day) {
      const {reviewObj = {}, typeOfContent} = value
      if( typeOfContent === "Largometrajes" || typeOfContent === "LARGOMETRAJES" ) {
        if(reviewObj && reviewObj.artisticInfo) {
          const {mainActors} = reviewObj.artisticInfo[0]
          if(day.actorsPreliminary) {
            day.actorsPreliminary = mainActors.length > 0 ? mainActors : []
          } else {
            let array = mainActors.length > 0 ? mainActors : []
            this.$set(day, 'actorsPreliminary', array)
          }
          this.showActorsSelect.statusSelect = mainActors.length > 0 ? true : false
          this.showActorsSelect.statusGeneral = true
        } else {
          this.showActorsSelect.statusSelect = false
          this.showActorsSelect.statusGeneral = true
        }
      } else {
        this.showActorsSelect.statusGeneral = false
      }
    },
    showNameProviderAndPositionInContract (value, day, index ) {
      const { typeOfContent, contractPosition, canned, providerName, contractCode, codMaterial } = value
      if ( typeOfContent === "Largometrajes" && canned == true  ) {
        // day.contractPosition = contractPosition
        this.nombreDelProveedor = providerName
        this.positionMat = contractPosition
        // day.providerName = providerName
      }
      else if (typeOfContent === "LARGOMETRAJES" && canned == true && contractCode !== null && contractPosition == '' ) {
        this.nombreDelProveedor = providerName
        HTTP.get('contracts/contractCode/'+ contractCode + '/geminisCodeMaterial/' + codMaterial + '/positionMaterialInContract')
        .then(response => {
          this.positionMat = response.data.positionMaterialInContract
          this.updateContractPositionInMaterial(this.positionMat)
        })
        .catch(err => console.log(err))
      }
      else if (typeOfContent === "LARGOMETRAJES" && canned == true && contractPosition !== '') {
        this.nombreDelProveedor = providerName
        this.positionMat = contractPosition
      }
    },
    updateContractPositionInMaterial (position) {
      let idMat = this.itemObject._id ? this.itemObject._id : this.itemObject.__id
      HTTP.patch('materials/update/' + idMat, 
      [{ propName: "contractPosition", value: position } ])
      .then(data => {
         this.$store.dispatch('getData', 'materials/allMaterials/allMaterials')
      })
      .catch(err => console.log(err))
    },
    showActorsEdit(value) {
      const {firstActor, secondActor, actorsPreliminary, typeOfContent} = value
      if( typeOfContent === "Largometrajes" || typeOfContent === "LARGOMETRAJES" ) {
        this.showActorsSelect.statusGeneral = true
        if(actorsPreliminary.length > 0) {
          this.showActorsSelect.statusSelect = true
        } else {
          this.showActorsSelect.statusSelect = false
        }
      } else {
        this.showActorsSelect.statusGeneral =  false
      }
    }
  },
  computed: {
    isInCompleteForm() {
      return this.isInScheduleComplete || this.isChapInComplete
    },
    isCompleteAllCards() {
      if(this.newGrid && this.newGrid.cardsData) {
         let data = this.newGrid.cardsData.map((e) => {
          const {scheduleStartHour,
          scheduleStartMin,
          scheduleEndHour,
          scheduleEndMin} = e

          return {scheduleStartHour,
          scheduleStartMin,
          scheduleEndHour,
          scheduleEndMin}
        })
        // console.log(data, 'data')
        return data
      }
    },
    isTheseDayHaveChap() {
      if(this.newGrid && this.newGrid.cardsData) {
        let arr = []
        this.newGrid.cardsData.forEach((e) => {
          const { chapters, isShowTemporadas } = e
          if(isShowTemporadas == true) {
            arr.push(chapters)
          }
        })
        return arr.length >= 1 ? [].concat.apply([], arr) : arr
      }
    },
  },
  watch: {
    // newGrid(value) {
    //   this.newGrid = value
    //   console.log(value, 'newGrid value')
    // },
    arrSignalsCode(val) {
      if(val === 13) {
        this.isIndeterminate = false
      } else {
        this.isIndeterminate = !this.checkAll
      }
    },
    isCompleteAllCards: {
      handler(data, oldVal) {
        let a =  Boolean(data.filter((e) => e.scheduleStartHour == '').length)
        let b =  Boolean(data.filter((e) => e.scheduleStartMin == '').length)
        let c =  Boolean(data.filter((e) => e.scheduleEndHour == '').length)
        let d =  Boolean(data.filter((e) => e.scheduleEndMin == '').length)
        if(a == false && b == false && c == false && d == false) {
          this.isInScheduleComplete = false
        } else {
          this.isInScheduleComplete = true
        }
      },
      deep: true
    },
    isTheseDayHaveChap: {
      handler(data, oldVal) {
        let chapters = data.map((e) => {
          const {numChapter} = e
          return {numChapter}
        })
        if(chapters.length >= 1) {
          chapters.map((chap) => {
            const {numChapter} =  chap
            if(numChapter == ''|| numChapter == '0') {
              this.isChapInComplete = true
            } else {
              this.isChapInComplete = false
            }
          })
        } else {
          this.isChapInComplete = false
        }
      },
      deep: true
    },
    // ------
    // itemObject: {
    //   handler(val, oldVal) {
    //     if(val) {
    //       let channel = Boolean(val.checkedChanels.filter((e) => e == "América Next").length)
    //       if(!channel) {
    //         const signalsOfMaterial = val.checkedSignals
            
    //         let signalsCoincidence = this.isHaveAllSignalProgram.filter((e, i) => signalsOfMaterial.includes(e))
    //         let signalsDisabledIfMaterial = this.signalForProgram(this.isHaveAllSignalProgram, signalsCoincidence)
    //         this.signalsTrans = signalsDisabledIfMaterial

    //         let select = signalsDisabledIfMaterial.filter((e) => e.isDisabled == false)
    //         let selectFilter = select.map((e) =>(e.name))
    //         // console.log(selectFilter, 'selectFilter')
    //         this.newGrid.programInfo.checkedSignals = selectFilter

    //         if(selectFilter.length == 0) {
    //           this.notHaveSignalForProgram = true
    //           this.itemObject = {}
    //           this.verifyIfHasContentAll('', this.newGrid.cardsData)
    //         } else {
    //           this.notHaveSignalForProgram = false
    //         }
    //       }
    //     }
    //   },
    //   deep: true
    // }
  }
}
</script>

<style>
.el-checkbox.statusCheck {
  display: block;
  margin: 5px 0;
}

.el-checkbox.statusCheck + .el-checkbox.statusCheck {
  margin-left: 0px;
}
</style>
